Name: kernel-pcmcia-cs
%define pcmciaver 3.1.31
Version: %{pcmciaver}
Release: 13
Summary: The daemon for using PCMCIA adapters.
Group: System Environment/Kernel
Obsoletes: pcmcia-cs
Copyright: GPL
ExclusiveArch: i386
Epoch: 1
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: kernel-source, glibc-kernheaders >= 2.4-2
Source0: ftp://projects.sourceforge.net/pub/pcmcia-cs/pcmcia-cs-%{pcmciaver}.tar.gz
Source1: pcmcia-cs-2.8.8-network.script
Source2: pcmcia-cs-3.1.24-isdn.script
Source4: config.mk
Source5: config.h

Patch0: pcmcia-cs-3.1.18-script.patch
Patch1: pcmcia-cs-3.1.18-config.patch
Patch3: pcmcia-cs-3.1.24-rctrans.patch
Patch4: pcmcia-cs-3.1.23-yenta.patch
Patch5: pcmcia-cs-3.1.23-updfstab.patch
Patch6: pcmcia-cs-3.1.24-portrange.patch
Patch7: pcmcia-cs-3.1.24-wireless.patch
Patch8: pcmcia-cs-3.1.27-makefile.patch
Patch9: pcmcia-cs-3.1.27-loaderlib.patch
Patch10: pcmcia-cs-3.1.27-initorder.patch

%define _missing_doc_files_terminate_build    0
%define _unpackaged_files_terminate_build 0



Requires: kernel >= 2.4.3, chkconfig, kudzu >= 0.95, hotplug >= 2001_04_24-9
Requires: hwdata >= 0.60
BuildPreReq: kernel-source

%description
Many laptop machines (and some non-laptops) support PCMCIA cards for
expansion. Also known as "credit card adapters," PCMCIA cards are
small cards for everything from SCSI support to modems. PCMCIA cards
are hot swappable (i.e., they can be exchanged without rebooting the
system) and quite convenient to use. The kernel-pcmcia-cs package
contains a set of loadable kernel modules that implement an
applications program interface, a set of client drivers for specific
cards and a card manager daemon that can respond to card insertion and
removal events by loading and unloading drivers on demand.  The daemon
also supports hot swapping, so that the cards can be safely inserted
and ejected at any time.


%prep
%setup -n pcmcia-cs-%{version} -q
%patch0 -p1 -b .script
%patch1 -p2 -b .config
%patch3 -p1 -b .rctrans
%patch4 -p1 -b .yenta
%patch5 -p1 -b .fstab
%patch6 -p1 -b .portrange
%patch7 -p1 -b .wireless
%patch8 -p1
%patch9 -p1
%patch10 -p1
cp %{SOURCE4} .
cp %{SOURCE5} include/pcmcia
%build

#./Configure -n --kernel=/usr/src/linux-2.4 \
#	--target=$RPM_BUILD_ROOT --trust --cardbus --nopnp --srctree \
#	--moddir=/lib/modules/1.1.1 --sysv --rcdir=/etc/rc.d 

perl -pi -e 's/\/usr\/man/'`echo %{_mandir} | sed 's_/_\\\\/_g'`/ man/Makefile
make all
%ifarch i386
cd debug-tools
make lspnp
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_mandir}
make MANDIR=$RPM_BUILD_ROOT%{_mandir} PREFIX=$RPM_BUILD_ROOT install
install -m755 %{SOURCE1} $RPM_BUILD_ROOT/etc/pcmcia/network
install -m755 %{SOURCE2} $RPM_BUILD_ROOT/etc/pcmcia/isdn

# We need our own default /etc/sysconfig/pcmcia
cat > $RPM_BUILD_ROOT/etc/sysconfig/pcmcia <<EOF
PCMCIA=no
PCIC=
PCIC_OPTS=do_scan=0
CORE_OPTS=
CARDMGR_OPTS=-f
EOF

install -m755 debug-tools/lspnp $RPM_BUILD_ROOT/sbin/lspnp

rm -f $RPM_BUILD_ROOT/etc/pcmcia/config

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add pcmcia

%preun
if [ $1 = 0 ]; then
    /sbin/chkconfig --del pcmcia
fi
exit 0

%triggerpostun -- kernel-pcmcia-cs < 2.2.5
if [ -f /etc/rc.d/init.d/pcmcia ] ; then
    /sbin/chkconfig --add pcmcia
fi

%changelog
* Mon Dec  2 2002 Bill Nottingham <notting@redhat.com> 3.1.31-11
- fix exclusion of /etc/pcmcia/config

* Tue Nov 26 2002 Arjan van de Ven <arjanv@redhat.com>
- exclude range for Radeon ICP chipsets
- use modprobe not insmod

* Mon Nov  4 2002 Bill Nottingham <notting@redhat.com>
- move config to hwdata package, require it

* Fri Aug 30 2002 Preston Brown <pbrown@redhat.com>
- fix buffalo driver entry again

* Tue Aug 27 2002 Arjan van de Ven <arjanv@redhat.com>
- added some device ID's

* Mon May 13 2002 Jeremy Katz <katzj@redhat.com>
- merge changes from later 3.1.27 packages
  - add loader libs for cardmgr and probe to avoid sucking copy into anaconda
  - specify full path to kudzu in the initscript
  - config fixups for various wireless cards

* Mon Feb 11 2002 Arjan van de Ven <arjanv@redhat.com>
- upgrade to 3.1.31 upstream version

* Sun Aug 19 2001 Bill Nottingham <notting@redhat.com>
- strike that. I was on crack.

* Wed Aug  8 2001 Bill Nottingham <notting@redhat.com>
- don't run network script on device removal; hotplug will take care
  of it

* Mon Jul 16 2001 Bill Nottingham <notting@redhat.com>
- <foo>.opts should be %config(noreplace)
- the initscript should *not* be %config

* Mon Jul 09 2001 Arjan van de Ven <arjanv@redhat.com>
- make it build; fixed a few loose ends in the config file

* Sun Jul  8 2001 Bill Nottingham <notting@redhat.com>
- re-add the wireless patch

* Fri Jul 06 2001 Arjan van de Ven <arjanv@redhat.com>
- Updated to upstream 3.1.27
- fixed Compaq wavlan mapping to orinoco_cs

* Wed May  9 2001 Bill Nottingham <notting@redhat.com>
- add an entry for orinoco_cs, but don't map anything to it yet
- require kernel >= 2.4.3

* Thu Apr 26 2001 Bill Nottingham <notting@redhat.com>
- fix some screwed up driver mappings (apa1480_cb -> aic7xxx_mod, ieee1394
  stuff) (#37217)
- don't call ifdown with bogus parameters (#37353)

* Wed Apr 16 2001 Arjan van de Ven <arjanv@redhat.com>
- fix for bug 33169

* Sun Mar 11 2001 Than Ngo <than@redhat.com>
- add missing isdn script

* Sat Mar 10 2001 Preston Brown <pbrown@redhat.com>
- ad-hoc mode by default for wavelans

* Tue Feb 27 2001 Bill Nottingham <notting@redhat.com>
- require hotplug
- actually install the stubbed network script
- fix wireless script so it works when not called from the
  network script
- use xircom_cb, not tulip

* Tue Feb 27 2001 Erik Troan <ewt@redhat.com>
- don't bring network devices up or down, let hotplug take care of it

* Fri Feb 23 2001 Erik Troan <ewt@redhat.com>
- changed airo to aironet4500 in the config files
- combined some patches as it was a complete mess
- removed patch for 26955 which was just wrong -- it tried to source in
  /etc/pcmcia/wireless, which is a script that expects arguments

* Tue Feb 13 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add condrestart to init script, move start and stop to functions
  the way we do everywhere else
- start pcmcia earlier on in the boot process - needs to be started
  before netfs if we want to mount nfs filesystems using pcmcia network
  cards.

* Mon Feb 12 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Make tulip cards use "tulip" rather than "xircom_tulip_cb"
  (Request from Arjan)
- remove 0x800-0x8ff range from ports (#25222)
- network script sources wireless script (#26955)

* Mon Feb 12 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Actually apply Erik's fstab patch
- Add support for various PCMCIA ISDN cards to /etc/pcmcia/config
  (Sedlbauer SpeedStar/SpeedStar II, AVM M1/M2/B1/A1, Elsa MicroLink)
- Update to 3.1.24 while at it:
  - Fixes buffer overrun in cardmgr
  - Fixes config scripts
  - Fixes wvlan_cs man page
  - Fixes script logging for DHCP
  All other 3.1.24 changes don't affect us because we aren't using
  the modules from this package

* Sun Feb 11 2001 Bill Nottingham <notting@redhat.com>
- take suid bit off of cardctl (#27098)

* Thu Feb 08 2001 Erik Troan <ewt@redhat.com>
- transparently use yenta_socket instead of i82365 when appropriate
- call updfstab here and there

* Tue Jan 23 2001 Erik Troan <ewt@redhat.com>
- switched to echo $"string" for translations

* Tue Jan 16 2001 Erik Troan <ewt@redhat.com>
- switched to gprintf for translations

* Tue Jan 16 2001 Erik Troan <ewt@redhat.com>
- changed xircom_tulip to xircom_tulip_cb in /etc/pcmcia/config

* Thu Jan 11 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 3.1.23

* Mon Jan 08 2001 Erik Troan <ewt@redhat.com>
- split kernel-pcmcia-cs into separate package as all of the pcmcia modules
  are from the main kernel now, and this just contributes cardmgr and config
  stuff

%files
%defattr(-,root,root)
%doc doc/PCMCIA-HOWTO 
%doc doc/PCMCIA-PROG
%doc SUPPORTED.CARDS 
%doc CHANGES 
%doc COPYING 
%doc README
/sbin/probe
/sbin/cardmgr
%attr(755,root,root) /sbin/cardctl
/sbin/ifport
/sbin/ifuser
/sbin/lspnp
/sbin/scsi_info
/sbin/ide_info
/sbin/pcinitrd
/sbin/ftl_format
/sbin/ftl_check
/sbin/dump_cis
/sbin/pack_cis
%{_mandir}/man[45]/*
%{_mandir}/man8/*
/etc/pcmcia/cis
%dir /etc/pcmcia
%config(noreplace) /etc/pcmcia/config.opts
/etc/pcmcia/ftl
%config(noreplace) /etc/pcmcia/ftl.opts
/etc/pcmcia/ide
%config(noreplace) /etc/pcmcia/ide.opts
/etc/pcmcia/memory
%config(noreplace) /etc/pcmcia/memory.opts
/etc/pcmcia/network
/etc/pcmcia/isdn
/etc/pcmcia/parport
%config(noreplace) /etc/pcmcia/parport.opts
/etc/pcmcia/scsi
%config(noreplace) /etc/pcmcia/scsi.opts
/etc/pcmcia/serial
%config(noreplace) /etc/pcmcia/serial.opts
/etc/pcmcia/wireless
%config(noreplace) /etc/pcmcia/wireless.opts
/etc/pcmcia/shared
/etc/rc.d/init.d/pcmcia
%dir /var/lib/pcmcia
%config(noreplace) /etc/sysconfig/pcmcia
%{_libdir}/*_loader.a
